// Adapted to HLSL from https://www.shadertoy.com/view/XdcXzn
cbuffer vars : register(b0)
{
	float2 uResolution;
};
Texture2D tex : register(t0);
SamplerState smp : register(s0);


float contrast = 1.0;


float4x4 contrastMatrix( float contrast )
{
	float t = ( 1.0 - contrast ) / 2.0;
    
    return float4x4( contrast, 0, 0, 0,
                 0, contrast, 0, 0,
                 0, 0, contrast, 0,
                 t, t, t, 1 );
}


float4 main(float4 fragCoord : SV_POSITION) : SV_TARGET
{

    float2 uv = fragCoord.xy/uResolution;
    float4 rgba = tex.Sample(smp, uv);
    
	// Contrast 1
//    return saturate(pow(rgba, contrast));
    // Contrast 2
	return contrastMatrix( contrast ) * rgba;
}
